/**
 * Created by littwin on 14.03.15.
 */
app.controller('GCodeController', ['$scope', 'RSCom', '$filter', '$rootScope', 'FEQuestion', 'IPS','$uibModal','GSettingsR','RSPrinter','RSBrowseFolder','WaitSelectorAppear',
    function ($scope, RSCom, $filter, $rootScope, FEQuestion, ips, $uibModal, GSettingsR, RSPrinter,RSBrowseFolder,WaitSelectorAppear) {
        var local = RSPrinter.local();
        $scope.selectSFile = false;
        $scope.bfolder = RSBrowseFolder;
        $scope.printing = false;
        $scope.ips = ips;
        $scope.activeGCode = false;
        $scope.activeGCType = 0; // 0 = not selected, 1 = queue, 2 = model
        $scope.listType = 0; // 0 = icons, 1= deatils
        if(!$rootScope.globals) $rootScope.globals = {};
        if(!$rootScope.globals.group)
            $rootScope.globals.group = {};
        if(!$rootScope.globals.group[$scope.activeSlug])
            $rootScope.globals.group[$scope.activeSlug] = '#';
        $scope.groups = [{id:'*',name:"<?php _('Group: All') ?>"}];

        $rootScope.$on('selectActiveGCode',function(evt,val,list) {
            $scope.selectGCode(val,list);
        });

        var updateGroups = function() {
            RSCom.send("listModelGroups",{}).then(function(data) {
                $scope.groups = [{id:'*',name:"<?php _('Group: All') ?>"}];
                var hasGroup = "*" == $rootScope.globals.group[$scope.activeSlug];
                angular.forEach(data.groupNames,function(v) {
                    hasGroup = hasGroup || v == $rootScope.globals.group[$scope.activeSlug];
                    if(v == "#")
                        $scope.groups.push({id:"#",name:"<?php _('Group: Default') ?>"});
                    else
                        $scope.groups.push({id:v,name:"<?php _('Group:') ?> "+v});
                });
                if(!hasGroup) {
                    $rootScope.globals.group[$scope.activeSlug] = "#";
                    $scope.selectGroup();
                }
            });
        };
        updateGroups();
        $scope.$on('modelGroupListChanged', function () {
            updateGroups();
        });
        $scope.selectGroup = function() {
            updateFiles();
            $scope.listPos = 0;
        };
        $scope.selectQueue = function (gc, event) {
            elem = event.target;
            $scope.activeQueue = gc;
            $(elem).tooltip({
                title: '<div style="width:200px;text-align:left"><h4>' + "<?php _('Job Informations') ?></h4><?php _('Printing time') ?>: " + $filter('hms')(gc.printTime) +
                '<br>Extrusion: ' + Math.ceil(gc.filamentTotal) + ' mm</div>',
                html: true,
                placement: 'right',
                trigger: 'hover click'
            });
        };

        $scope.selectGCode = function (gc, tp) {
            $scope.activeGCode = gc;
            $scope.selectSFile = false;
            local.activeGCode = gc;
            $scope.activeGCType = tp;
            $scope.plist = [];
            var p = $rootScope.serverSettings.pricing;
            var map = p.map;

            function filamentIndex(uid) {
                if (!uid) return 0;
                var idx = 0;
                angular.forEach(p.filaments, function (f, i) {
                    if (f.u == uid)
                        idx = i;
                });
                return idx;
            }

            $scope.filaments = p.filaments;
            $scope.currency = p.currency;
            angular.forEach($scope.activeGCode.volumeUsage, function (vol, idx) {
                if (vol <= 0) return;
                $scope.plist.push({
                    extruder: idx + 1,
                    mm: $scope.activeGCode.extruderUsage[idx],
                    volume: vol * 0.001, price: 0,
                    filament: p.filaments[filamentIndex(map[idx.toString() + "_" + $scope.slug])],
                    weight: 0
                });
            });
            $scope.updateCalc = function () {
                $scope.weightTotal = 0;
                $scope.total = p.perPrint + p.perHour * $scope.activeGCode.printTime / 3600;
                angular.forEach($scope.plist, function (f) {
                    f.weight = f.volume * f.filament.w;
                    $scope.weightTotal += f.weight;
                    f.price = f.weight * f.filament.p / 1000.0;
                    $scope.total += f.price;
                });
            };

            $scope.updateCalc();
        };

        // Remove file from job list
        $scope.dequeQueue = function (gcode) {
            FEQuestion("<?php _('Security question') ?>", "<?php _('Do you really want to delete $1?') ?>".replace('$1', gcode.name), null, null, true).then(function () {
                RSCom.send("removeJob", {id: gcode.id});
            });
        };

        // Print file in job list
        $scope.printQueue = function (code) {
            $scope.preparePrint = true;
            RSCom.send("startJob", {id: code.id}).then(function () {
                $scope.preparePrint = false;
            });
        };

        // Stop running print job
        $scope.stopPrint = function () {
            FEQuestion("<?php _('Confirmation required') ?>", "<?php _('Really stop current print?') ?>", "<?php _('Yes') ?>", "<?php _('No') ?>", true).then(function () {
                if ($scope.active.status.jobid)
                    RSCom.send("stopJob", {id: $scope.active.status.jobid});
            });
        };

        // Pause running print job
        $scope.pausePrint = function () {
            RSCom.send("send", {cmd: "@pause <?php _('User requested pause.') ?>"});
        };

        // Continue running print job
        $scope.unpausePrint = function () {
            RSCom.send("continueJob", {});
        };

        // Copy model code to job list. If it is the only one print will start.
        $scope.printGCode = function (gcode,tp) {
            if(tp == 2) {
                $scope.preparePrint = true;
                RSCom.send("copyModel", {id: gcode.id}).then(function () {
                    $scope.preparePrint = false;
                });
            } else {
                $scope.printQueue(gcode);
            }
        };

        // Delete file
        $scope.removeGCode = function (gcode,tp) {
            FEQuestion("<?php _('Security question') ?>", "<?php _('Do you really want to delete $1?') ?>".replace('$1', gcode.name), null, null, true).then(function () {
                if (tp == 2) {
                    RSCom.send("removeModel", {id: gcode.id}).then(function () {
                        $scope.activeGCode = false;
                        $scope.activeGCType = 0;
                    });
                } else {
                    RSCom.send("removeJob", {id: gcode.id}).then(function () {
                        $scope.activeGCode = false;
                        $scope.activeGCType = 0;
                    });
                }
            });
        };
        $scope.deselectGCode = function() {
            $scope.activeGCType = 0;
            $scope.selectSFile = false;
        };

        // select a filament type for price calculation
        $scope.selectFilament = function (idx) {
            var dia = $uibModal.open({
                templateUrl: 'views/dialogs/selectfilament.html?lang=' + lang,
                scope: $scope,
                controller: ['$scope', function ($scope2) {
                    $scope2.selectFilament = function(f) {
                        $scope.plist[idx].filament = f;
                        $scope.updateCalc();
                        $scope2.$close();
                    }
                }],
                size: 'lg'
            });
        };

        // Navigate file pages
        $scope.listPos = 0;
        $scope.next = function() {
            $scope.listPos += $rootScope.serverSettings.frontSetting.listPerPage;
        };
        $scope.previous = function() {
            $scope.listPos -= $rootScope.serverSettings.frontSetting.listPerPage;
        };

        // Setup initial sorting
        var updateFiles = function()
        {
            local.sortModelBy = $rootScope.serverSettings.frontSetting.listSort; // uneven = desc 0 = name, 2 = created, 4 = print time, 6 = size, 8 = lines, 10 = filament, 12 = layer
            local.modelFilter = '';
            local.activeGroup = $rootScope.globals.group[$scope.activeSlug];
            RSPrinter.sortModelsFor($rootScope.activeSlug);
        };
        updateFiles();

        // browser for files

        $scope.importFolderPath = function(path) {
            if(path.isDir) {
                RSBrowseFolder.activeFolderPath = path.path;
                RSBrowseFolder.updateFiles("");
                return;
            }
            WaitSelectorAppear.show("Uploading Files",10);
            var arr = [{name:path.name,url:"folder://"+RSBrowseFolder.selectedFolder+path.path,job:$scope.importAsJob}];
            RSCom.send("importURL",{files:arr,folder:$rootScope.globals.group[$scope.activeSlug]}).then(function(data) {
                if(data.ok)
                    WaitSelectorAppear.bindToMsgId(data.msgId);
                else
                    WaitSelectorAppear.hide();
            },function() {
                WaitSelectorAppear.hide();
            });
            $scope.selectSFile = false;
        };
        $scope.abortFileSelection = function() {
            $scope.selectSFile = false;
        };
        $scope.selectedFolderChanged = function() {
            RSBrowseFolder.activeFolderPath = "";
            RSBrowseFolder.updateFiles();
        };

        $scope.importPath = function(folder,job) {
            $scope.selectSFile = true;
            $scope.importAsJob = job;
            RSBrowseFolder.selectedFolder = folder.id;
            RSBrowseFolder.activeFolderPath = "";
            RSBrowseFolder.filter="gcode";
            RSBrowseFolder.updateFiles();
        };
        $scope.importSelectedFiles = function() {
            var arr = [];
            angular.forEach(RSBrowseFolder.filesInPath,function(v) {
                if(!v.selected) return;
                arr.push({name:v.name,url:"folder://"+RSBrowseFolder.selectedFolder+v.path,job:$scope.importAsJob})
            });
            if(arr.length == 0) return;
            WaitSelectorAppear.show("Uploading Files",10);
            RSCom.send("importURL",{files:arr,folder:$rootScope.globals.group[$scope.activeSlug]}).then(function(data) {
                if(data.ok)
                    WaitSelectorAppear.bindToMsgId(data.msgId);
                else
                    WaitSelectorAppear.hide();
            },function() {
                WaitSelectorAppear.hide();
            });
            $scope.selectSFile = false;
        };
    }]);

app.controller('ControlController', ['$scope', '$rootScope', 'KeyboardInteger', 'RSPrinter', 'RSCom','RSOverview', function ($scope, $rootScope, KeyboardInteger, RSPrinter, RSCom, RSOverview) {
    $scope.moveDistance = 10; // Default move distance
    $scope.RSPrinter = RSPrinter;
    $scope.xMoveRel = function (x) {
        RSCom.send("move", {x: x, relative: true});
        RSOverview.updateStateNow();
    };

    $scope.yMoveRel = function (y) {
        RSCom.send("move", {y: y, relative: true});
        RSOverview.updateStateNow();
    };

    $scope.zMoveRel = function (z) {
        RSCom.send("move", {z: z, relative: true});
        RSOverview.updateStateNow();
    };

    $scope.eMoveRel = function (x, speed) {
        RSCom.send("move", {e: x, relative: true, speed: speed});
        RSOverview.updateStateNow();
    };

}]);

app.controller('ConfigController', ['$scope', 'RSOverview','IPS','RSCom','$state', function ($scope, RSOverview,ips,RSCom,$state) {
    $scope.ips = ips;
    $scope.disk = {};
    RSCom.send('freeSpace',{}).then(function(d) {
        $scope.disk = d;
        $scope.disk.usage = 100 - 100 * (d.available / d.capacity);
        if(d.capacity < 500*1024*1024)
            $scope.disk.class = 'progress-bar-danger';
        else
            $scope.disk.class = 'progress-bar-success';
    });
    $scope.selectPrinter = function (p) {
        RSOverview.selectPrinter(p.slug);
    };
}]);

app.controller('ConfigBasicController', ['$scope', '$rootScope', 'GSettings', 'KeyboardFloat', 'RSCom', 'KeyboardInteger',
    function ($scope, $rootScope, GSettings, KeyboardFloat, RSCom, KeyboardInteger) {
        $rootScope.$watchCollection('serverSettings.frontSetting', function (newVal, oldVal) {
            if (!oldVal) return;
            GSettings.serverSettingsChanged().then(function () {
                if (newVal.language != oldVal.language) { // load new language
                    $scope.selectLanguage(newVal.language);
                }
            });
        });
        $scope.currentLang = function () {
            v = null;
            angular.forEach($scope.supportedLanguages, function (l) {
                if (l.id == window.lang)
                    v = l;
            });
            return v;
        };
        $scope.changeListPerPage = function () {
            KeyboardInteger(" <?php _('G-Codes per Page') ?>", "rs rs-file-gcode", 5, 100, "<?php _('Files') ?>", $rootScope.serverSettings.frontSetting.listPerPage).then(function (s) {
                $rootScope.serverSettings.frontSetting.listPerPage = s;
            });
        };
        $scope.changeXYSpeed = function () {
            KeyboardFloat(" <?php _('XY Speed') ?>", "fa fa-arrows", 1, 5000, "mm/s", $rootScope.activeConfig.movement.xySpeed).then(function (s) {
                $rootScope.activeConfig.movement.xySpeed = s;
                RSCom.send("setPrinterConfig", $rootScope.activeConfig);
            });
        };
        $scope.changeZSpeed = function () {
            KeyboardFloat(" <?php _('Z Speed') ?>", "fa fa-arrows-v", 1, 5000, "mm/s", $rootScope.activeConfig.movement.zSpeed).then(function (s) {
                $rootScope.activeConfig.movement.zSpeed = s;
                RSCom.send("setPrinterConfig", $rootScope.activeConfig);
            });
        };
        $scope.changeExtrSlowSpeed = function (idx) {
            KeyboardFloat(" <?php _('Extrude/Slow Speed') ?>", "rs rs-extruder", 1, 5000, "mm/s", $rootScope.activeConfig.extruders[idx].extrudeSpeed).then(function (s) {
                $rootScope.activeConfig.extruders[idx].extrudeSpeed = s;
                RSCom.send("setPrinterConfig", $rootScope.activeConfig);
            });
        };
        $scope.changeExtrFastSpeed = function (idx) {
            KeyboardFloat(" <?php _('Retract/Fast Speed') ?>", "rs rs-extruder", 1, 5000, "mm/s", $rootScope.activeConfig.extruders[idx].retractSpeed).then(function (s) {
                $rootScope.activeConfig.extruders[idx].retractSpeed = s;
                RSCom.send("setPrinterConfig", $rootScope.activeConfig);
            });
        };
    }]);

app.controller('ConfigNetworkController', ['$scope', 'IPS', function ($scope, ips) {
    $scope.ips = ips;
}]);
