﻿/* 
	DraggScroll is a JQuery extension for scrolling by clicking and dragging from within a container.
	Author: James Climer (http://climers.com)
	Released under the Apache V2 License: http://www.apache.org/licenses/LICENSE-2.0.html
	Requires JQuery: http://jquery.com	
	Get latest version from: https://github.com/jaclimer/JQuery-DraggScroll
	
    options: Currently not used
*/
;
(function($){
    $.event.special.destroyed = {
        remove: function(o) {
            if (o.handler) {
                o.handler()
            }
        }
    }
})(jQuery);

(function ($) {
    $.fn.dragScroll = function (options) {
        /* Mouse dragg scroll */
        var x, y, top, left, down,moved = false;
        var $scrollArea = $(this);

        $($scrollArea).attr("onselectstart", "return false;");   // Disable text selection in IE8

        var doMousedown = function (e) {
            //e.preventDefault();
            down = true;
            moved = false;
            x = e.pageX;
            y = e.pageY;
            top = $(this).scrollTop();
            left = $(this).scrollLeft();
        };
        var doMouseleave = function (e) {
            down = false;
        };
        var doClick = function(e) {
            if(moved) {
                e.stopPropagation();
                e.preventDefault();
            }
        };
        var doMousemove = function (e) {
            if (down) {
                var newX = e.pageX;
                var newY = e.pageY;
                $($scrollArea).scrollTop(top - newY + y);
                $($scrollArea).scrollLeft(left - newX + x);
                if(Math.abs(x-newX)>2 || Math.abs(y-newY)>2)
                    moved = true;
            }
        };
        var doMouseup = function (e) {
            down = false;
        };

        $($scrollArea).mousedown(doMousedown);
        $($scrollArea).mouseleave(doMouseleave);
        $($scrollArea)[0].addEventListener(
            'click',
            doClick,
            true // <-- This registeres this listener for the capture phase instead of the bubbling phase!
        );
        $("body").mousemove(doMousemove);
        $("body").mouseup(doMouseup);
        $($scrollArea).bind('destroyed', function() {
            $($scrollArea).unbind("mousedown",doMousedown);
            $($scrollArea).unbind("mouseleave",doMouseleave);
            $($scrollArea).unbind("click",doClick);
            $("body").unbind("mousemove",doMousemove);
            $("body").unbind("mouseup",doMouseup);
        });
    };
})(jQuery);