<div class="row"> <div class="col-lg-12"> <div><h1><?php _('Printer Configuration Wizard') ?></h1> </div> <div ng-show="step==1"> <h2><?php _('Step 1: Naming') ?></h2> <p><?php _('This wizard will guide you through the basic setup of a new printer. It will ask only the basic settings and fill in remaining values with values taken from firmware or with default values, so you start quickly. For a perfect setup, you should visit the configuration screen and correct missing or wrong values.') ?></p> <form novalidate name="form1"> <div class="form-group"> <label><?php _("Printer Name") ?></label> <input type="text" class="form-control" ng-model="newprinter.name" placeholder="<?php _('Enter Printer Name') ?>" required> <inputerror error="newprinter.errors.name"></inputerror> </div>  <button class="btn btn-primary" ng-disabled="form1.$invalid" ng-click="step1()"><?php _('Continue with Step 2') ?> <i class="fa fa-arrow-circle-o-right rs-big"></i></button> <button class="btn btn-danger pull-right" ng-click="abort()"> <i class="fa fa-trash rs-bigtab"></i> <?php _('Abort') ?> </button> </form> </div> <div ng-show="step==2" class="units"> <h2><?php _('Step 2: Connecting Printer') ?></h2> <form name="form2" novalidate> <div class="form-group"> <label><?php _('Firmware') ?></label> <select class="form-control" ng-model="editor.general.firmwareName" ng-options="f for f in firmware.firmwareNames"> </select> </div> <div class="form-group"> <label><?php _('Connection Method') ?></label> <select class="form-control" ng-model="editor.connection.connectionMethod" ng-options="f.i as f.n for f in conMethods"> </select> </div> <div ng-if="editor.connection.connectionMethod===0"> <div class="form-group"> <label><?php _('Device / Port') ?></label> <div class="input-group"> <input class="form-control" type="text" placeholder="" ng-model="editor.connection.serial.device" popover-placement="bottom" uib-popover="<?php _('For windows systems, this is the port COMx. On unix this is the path to the serial device like: /dev/tty.USB0') ?>" popover-trigger="'focus'"> <span class="input-group-btn"> <div class="btn-group" uib-dropdown is-open="menuPort"> <button type="button" class="btn btn-default" uib-dropdown-toggle> <?php _('Ports') ?> <span class="caret"></span> </button> <ul uib-dropdown-menu class="dropdown-menu-right" role="menu" style="max-height:200px;overflow:auto">  <li ng-repeat="p in config.ports track by $index"> <a href="javascript:void(0)" ng-click="editor.connection.serial.device=p;$parent.menuPort=false">{{p}}</a> </li> </ul> </div> </span> </div> </div> <div class="form-group"> <label><?php _('Baud Rate') ?></label> <select class="form-control" ng-model="editor.connection.serial.baudrate" ng-options="b.id as b.t for b in baudrates"></select> </div> <div class="form-group"> <label><?php _('RTS') ?></label> <select class="form-control" ng-model="editor.connection.serial.rts" ng-options="f.i as f.n for f in resetOrder"> </select> </div> <div class="form-group"> <label><?php _('DTR') ?></label> <select class="form-control" ng-model="editor.connection.serial.dtr" ng-options="f.i as f.n for f in resetOrder"> </select> </div> <p> <small><?php _('RTS/DTR are serial pins that normally are used to reset the printer or are ignored. If a printer interprets them differently you can select a setting that works.') ?></small> </p> <div class="form-group checkbox" ng-if="serverSettings.ServerOS===2"> <label><input type="checkbox" ng-model="editor.connection.serial.malyanHack"> <?php _('Use fix for Malyan boards') ?></label> </div> </div> <div ng-if="editor.connection.connectionMethod === 1"> <div class="form-group"> <label><?php _('File') ?></label> <input class="form-control" type="text" placeholder="<?php _('Path to pipe/socket') ?>" ng-model="editor.connection.pipe.file"> </div> </div> <div ng-if="editor.connection.connectionMethod === 2"> <div class="form-group"> <label><?php _('IP') ?></label> <input class="form-control" type="text" placeholder="<?php _('IP or domain name') ?>" ng-model="editor.connection.ip.address" popover-placement="bottom" popover-trigger="'focus'" uib-popover="<?php _('IP or domain name. No HTTP or similar!') ?>"> </div> <div class="form-group"> <label><?php _('Port') ?></label> <input class="form-control" type="number" placeholder="<?php _('Port') ?>" ng-model="editor.connection.ip.port" popover-placement="bottom" popover-trigger="'focus'" uib-popover="<?php _('Smoothieware uses 23. Legal values are from 1-65535') ?>"> </div> </div> <div class="form-group"> <label><?php _('Input Buffer Size') ?></label> <input class="form-control" type="number" placeholder="" ng-model="editor.connection.serial.inputBufferSize" popover-placement="bottom" uib-popover="<?php _('Size of bytes the incoming queue of your printer can store. Typical values are 127 and 63 byte.') ?>" popover-trigger="'focus'"> </div> <button class="btn btn-primary" ng-disabled="form2.$invalid" ng-click="step2()"> <?php _('Continue with Step 3') ?> <i class="fa fa-arrow-circle-o-right rs-big"></i></button> <button class="btn btn-danger pull-right" ng-click="abort()"> <i class="fa fa-trash rs-bigtab"></i> <?php _('Abort') ?> </button> <div class="margin-top"> <div class="alert alert-info" ng-show="substep==1"> <i class="fa fa-spin fa-spinner"></i> <?php _('Waiting for connection ...') ?></div> <div ng-show="substep==2" class="alert alert-success"> <i class="fa fa-check"></i> <?php _(' Connected.') ?> </div> <div ng-show="connectionDataWrong" class="alert alert-danger"> <i class="fa fa-exclamation-triangle"></i> <?php _('No understandable response on this port. Please check baud rate and firmware.') ?> </div> <div ng-show="portWrong" class="alert alert-danger"> <i class="fa fa-exclamation-triangle"></i> <?php _('Could not start connection with set port. Please select the right one!') ?> </div> <div ng-show="autodetectingBaudrate" class="alert alert-info"> <i class="fa fa-spin fa-spinner"></i> <?php _('Autodetecting baud rate ... testing: ') ?> {{testBaudrate}} </div> <div ng-show="autodetectingBaudrateFailed" class="alert alert-info"> <i class="fa fa-exclamation-triangle"></i> <?php _('Autodetecting baud rate failed.') ?> </div> <div ng-show="substep==2" class="alert alert-info"><?php _('Fetching firmware data ...') ?></div> </div> </form> </div> <div ng-show="step==3" class="units"> <h2><?php _('Step 3: Geometry') ?></h2> <form name="form3" novalidate> <p> <i class="fa margin-left fa-dot-circle-o fg-success"></i> <?php _('Value matches firmware value ') ?><br> <i class="fa margin-left fa-circle-o fg-danger"></i> <?php _('Value does not match firmware value') ?><br> </p> <div class="row"> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Bed Shape') ?></label> <select ng-model="editor.shape.basicShape.shape" class="form-control"> <option value="rectangle"><?php _('Rectangle') ?></option> <option value="circle"><?php _('Circle') ?></option> </select> </div> </div> <div class="row" ng-if="editor.shape.basicShape.shape == 'rectangle'"> <div class="col-md-3 col-xs-6 form-group"> <label><?php _('X left') ?> <autoset name="XMin" ng-model="editor.shape.basicShape.xMin"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="editor.shape.basicShape.xMin" required> <div class="input-group-addon">mm</div> </div> </div> <div class="col-md-3 col-xs-6 form-group"> <label><?php _('Y front') ?> <autoset name="YMin" ng-model="editor.shape.basicShape.yMin"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="editor.shape.basicShape.yMin" required> <div class="input-group-addon">mm</div> </div> </div> <div class="col-md-3 col-xs-6 form-group"> <label><?php _('X right') ?> <autoset name="XMax" ng-model="editor.shape.basicShape.xMax"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="editor.shape.basicShape.xMax" required> <div class="input-group-addon">mm</div> </div> </div> <div class="col-md-3 col-xs-6 form-group"> <label><?php _('Y rear') ?> <autoset name="YMax" ng-model="editor.shape.basicShape.yMax"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="editor.shape.basicShape.yMax" required> <div class="input-group-addon">mm</div> </div> </div> </div> <div class="row" ng-if="editor.shape.basicShape.shape == 'circle'">  <div class="col-sm-3 col-xs-6 form-group"> <label><?php _('Radius') ?> <autoset name="printableRadius" ng-model="editor.shape.basicShape.radius"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="editor.shape.basicShape.radius" required> <div class="input-group-addon">mm</div> </div> </div> </div> <div class="row"> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Z-Max') ?> <autoset name="ZMax" ng-model="editor.shape.basicShape.zMax"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="editor.movement.zMax" min="1" required> <div class="input-group-addon">mm</div> </div> </div> </div> <button class="btn btn-primary" ng-disabled="form3.$invalid" ng-click="step3()"> <?php _('Continue with Step 4') ?> <i class="fa fa-arrow-circle-o-right rs-big"></i></button> <button class="btn btn-danger pull-right" ng-click="abort()"> <i class="fa fa-trash rs-bigtab"></i> <?php _('Abort') ?> </button> </form> </div> <div ng-show="step==4" class="units"> <h2><?php _('Step 4: Extruders and Bed') ?></h2> <form name="form4" novalidate> <div class="form-group"> <label><?php _('Number of Extruders') ?> <autoset name="extruderCountSend" ng-model="extruder.num"> </autoset></label> <input class="form-control" type="number" step="1" placeholder="" ng-model="extruder.num" required min="0"> </div> <div class="form-group"> <label><?php _('Filament Diameter') ?></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="extruder.diameter" required min="0.1"> <div class="input-group-addon">mm</div> </div> </div> <div> <label><?php _('Heated Bed Installed') ?> <autoset name="hasHeatedBed" ng-model="extras.heatedBed"> </autoset></label><br> <boolswitch class="small" on="<?php _('Yes') ?>" off="<?php _('No') ?>" ng-model="extras.heatedBed"></boolswitch> </div> <div> <label><?php _('Heated Chamber Installed') ?> <autoset name="hasHeatedChamber" ng-model="extras.heatedChamber"> </autoset></label><br> <boolswitch class="small" on="<?php _('Yes') ?>" off="<?php _('No') ?>" ng-model="extras.heatedChamber"></boolswitch> </div> <div class="margin-top"> <button class="btn btn-primary" ng-disabled="form4.$invalid" ng-click="step4()"> <?php _('Continue with Step 5') ?> <i class="fa fa-arrow-circle-o-right rs-big"></i></button> <button class="btn btn-danger pull-right" ng-click="abort()"> <i class="fa fa-trash rs-bigtab"></i> <?php _('Abort') ?> </button> </div> </form> </div> <div ng-show="step==5"> <h2><?php _('Step 5: Features') ?></h2> <form name="form5" novalidate> <div class="row"> <div class="col-lg-4 col-xs-6"> <label><?php _('Fans Installed') ?> <autoset name="fansInstalled" ng-model="editor.general.numFans"> </autoset></label> <div> <input type="number" ng-model="editor.general.numFans" min="0" step="1"> </div> </div>  <div class="col-lg-4 col-xs-6"> <label><?php _('Software Power') ?> <autoset name="softwarePowerSwitch" ng-model="editor.general.softwarePower"> </autoset></label> <div> <boolswitch class="small" on="<?php _('Yes') ?>" off="<?php _('No') ?>" ng-model="editor.general.softwarePower"></boolswitch> </div> </div> </div> <div class="margin-top"> <button class="btn btn-primary" ng-disabled="form5.$invalid" ng-click="step5()"> <?php _('Finish') ?> <i class="fa fa-arrow-circle-o-right rs-big"></i></button> <button class="btn btn-danger pull-right" ng-click="abort()"> <i class="fa fa-trash rs-bigtab"></i> <?php _('Abort') ?> </button> </div> </form> </div> </div> </div>