<div class="tab-pane active"> <ng-form name="formExtruder"> <div ng-hide="config.hasErrors() || active.status.online != 1" class="panel panel-default margin-top"> <div class="panel-heading"><i class="fa fa-magic rs-fw"></i> <?php _('Heatup and Cooldown Wizard') ?></div> <div class="panel-body"> <div ng-if="hswStep==0"> <p><?php _('One question you probably can not answer is the heatup and cooldown speed. So once your bed and extruders are configured, you can run this wizard, which will measure the values. This can take some time, because it heats and cools down all parts.') ?></p> <button class="btn btn-primary" ng-click="hswStart1()"><?php _('Start Wizard') ?> <i class="fa fa-arrow-circle-right rs-bigtab"></i></button> </div> <div ng-if="hswStep==1"> <p><?php _('We will measure the time to heat up to your prefered temperature. So enter your preferred printing temperatures and cool down all heaters to room temperature. Then press "Start Measurement". Make sure your printer has power!') ?></p> <h4><?php _('Preferred Temperatures') ?></h4> <div class="row"> <div ng-repeat="h in hwsMeasurements" class="form-group col-md-6 col-xs-12 col-sm-6 col-lg-3"> <label>{{h.name}}</label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="h.target" min="0.0001"> <div class="input-group-addon">°C</div> </div> </div> </div> <button class="btn btn-primary" ng-click="hswStart2()"><?php _('Start Measurement') ?> <i class="fa fa-arrow-circle-right rs-bigtab"></i></button> </div> <div ng-if="hswStep==2"> <div class="alert alert-info"> <i class="fa fa-spin fa-spinner rs-bigtab"></i> <?php _('Measurement in progress. Do not leave this page until finished or heaters could stay on!') ?> </div> <h4><?php _('Measurement State') ?></h4> <table class="table table-bordered"> <tr ng-repeat="h in hwsMeasurements"> <td>{{h.name}}</td> <td>{{h.modeText}}</td> <td>{{h.actTemp | number:1}}°C</td> </tr> </table> </div> <div ng-if="hswStep==3"> <div class="alert alert-info"><?php _('Heating and cooling speeds were computed and stored.') ?></div> </div> </div> </div> <div class="panel panel-default margin-top"> <div class="panel-heading"><i class="rs rs-heated-bed rs-fw"></i> <?php _('Heated Bed') ?> <div ng-if="editor.heatedBeds.length===0" class="btn btn-primary btn-xs pull-right" ng-click="addBed()"><i class="fa fa-plus"></i> <?php _('Add Heated Bed') ?></div> </div> <div class="panel-body"> <div ng-repeat="b in editor.heatedBeds track by $index" ng-init="bed = $index" class="margin-bottom"> <h3>Bed {{$index+1}}</h3> <div class="row"> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Max. Temperature') ?> <autoset name="maxBedTemp" ng-model="b.maxTemp"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="b.maxTemp" popover-placement="bottom" uib-popover="<?php _('Maximum bed temperature.') ?>" popover-trigger="'focus'" min="0.0001"> <div class="input-group-addon">°C</div> </div> </div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Heatup Speed') ?></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="b.heatupPerSecond" popover-placement="bottom" uib-popover="<?php _('Temperature raised within one second.') ?>" data-original-title popover-trigger="'focus'" min="0.0001"> <div class="input-group-addon">°C/s</div> </div> </div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Cooldown Speed') ?></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="b.cooldownPerSecond" popover-placement="bottom" uib-popover="<?php _('Temperature drop per second.') ?>" data-original-title popover-trigger="'focus'" min="0.0001"> <div class="input-group-addon">°C/s</div> </div> </div> </div> <h4><?php _('Predefined Bed Temperatures') ?></h4> <table class="table table-bordered table-striped" style="max-width:520px"> <tr> <th><?php _('Name') ?></th> <th><?php _('Temperature') ?></th> <th style="width: 150px"> <button class="btn btn-primary btn-xs" ng-click="bedTempAdd(bed)"><i class="fa fa-plus"></i> <?php _('Add') ?></button> </th> </tr> <tr ng-repeat="r in b.temperatures track by $index"> <td><input type="text" ng-model="r.name" class="form-control input-sm" required> </td> <td> <div class="input-group maxw150"> <input type="number" ng-model="r.temp" class="form-control input-sm" integer required min="0"> <div class="input-group-addon">°C</div> </div> </td> <td> <button ng-hide="$first" class="btn btn-default btn-sm" ng-click="bedTempUp(bed, $index)"> <i class="fa fa-arrow-up rs-big"></i> </button> <button ng-hide="$last" class="btn btn-default btn-sm" ng-click="bedTempDown(bed, $index)"> <i class="fa fa-arrow-down rs-big"></i> </button> <button class="btn btn-danger btn-sm pull-right" ng-click="bedTempDel(bed, $index)"> <i class="fa fa-trash-o rs-big"></i> </button> </td> </tr> </table> <div class="btn btn-danger" ng-click="delBed(bed)"><i class="fa fa-tash-o"></i> <?php _('Remove Heated Bed') ?></div> </div> </div> </div> <div class="panel panel-default margin-top"> <div class="panel-heading"><i class="rs rs-chamber rs-fw"></i> <?php _('Heated Chamber') ?> <div ng-if="editor.heatedChambers.length===0" class="btn btn-primary btn-xs pull-right" ng-click="addChamber()"><i class="fa fa-plus"></i> <?php _('Add Heated Chamber') ?></div> </div> <div class="panel-body"> <div ng-repeat="c in editor.heatedChambers track by $index"> <h3>Heated Chamber {{$index+1}}</h3> <div class="row"> <div class="col-lg-12 col-xs-12 form-group"> <label><?php _('Max. Temperature') ?> <autoset name="maxChamberTemp" ng-model="c.maxTemp"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="c.maxTemp" popover-placement="bottom" uib-popover="<?php _('Maximum chamber temperature.') ?>" popover-trigger="'focus'" min="0.0001"> <div class="input-group-addon">°C</div> </div> </div> </div> <div class="btn btn-danger" ng-click="delChamber($index)"><i class="fa fa-tash-o"></i> <?php _('Remove Heated Chamber') ?></div> </div> </div> </div> <div class="panel panel-default margin-top"> <div class="panel-heading"><i class="rs rs-extruder rs-fw"></i> <?php _('General Extruder Parameter') ?> </div> <div class="panel-body"> <h4><?php _('Extrusion Mode') ?></h4> <p><?php _('Firmwares can run in volumetric extrusion mode or not. This has a big impact on the extruder values that get send. So it is also important to know in which mode your firmware runs and what to assume for slicer results. This value defines the default, if not stated otherwise. Use the following comments to mark a g-code volumetric or distance controlled.') ?></p> <pre><code>; Volumetric extrusion:1
; Volumetric extrusion:0</code></pre> <div class="row"> <div class="col-lg-4 col-xs-6"> <label><?php _('Default to Volumetric Extrusion') ?></label> <div> <boolswitch class="small" on="<?php _('Yes') ?>" off="<?php _('No') ?>" ng-model="editor.general.defaultVolumetric"></boolswitch> </div> </div> </div> <h4><?php _('Retraction Moves') ?></h4> <p><?php _('These settings are used in case your slicer uses G10/G11 commands for retraction. Only with the right values a correct time prediction is possible. You can ignore this if your printer does not support these commands.') ?></p> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Retraction Distance') ?> <autoset name="RetractionLength" ng-model="editor.movement.G10Distance"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="editor.movement.G10Distance" popover-placement="bottom" uib-popover="<?php _('Distance for a normal retract.') ?>" data-original-title popover-trigger="'focus'" min="0"> <div class="input-group-addon">mm</div> </div> </div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Retraction Distance Long') ?> <autoset name="RetractionLongLength" ng-model="editor.movement.G10LongDistance"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="editor.movement.G10LongDistance" popover-placement="bottom" uib-popover="<?php _('Distance for a long retract. Normally used when extruders get switched.') ?>" data-original-title popover-trigger="'focus'" min="0"> <div class="input-group-addon">mm</div> </div> </div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Retraction Speed') ?> <autoset name="RetractionSpeed" ng-model="editor.movement.G10Speed"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="editor.movement.G10Speed" popover-placement="bottom" uib-popover="<?php _('Speed of the retraction.') ?>" data-original-title popover-trigger="'focus'" min="0.1"> <div class="input-group-addon">mm/s</div> </div> </div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Z-Lift') ?> <autoset name="RetractionZLift" ng-model="editor.movement.G10ZLift"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="editor.movement.G10ZLift" popover-placement="bottom" uib-popover="<?php _('Distance z axis gets lifted.') ?>" data-original-title popover-trigger="'focus'" min="0"> <div class="input-group-addon">mm</div> </div> </div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Undo Extra Distance') ?> <autoset name="RetractionUndoExtraLength" ng-model="editor.movement.G11ExtraDistance"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="editor.movement.G11ExtraDistance" popover-placement="bottom" uib-popover="<?php _('Gets added to normal retraction distance when reversing.') ?>" data-original-title popover-trigger="'focus'" min="0"> <div class="input-group-addon">mm</div> </div> </div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Undo Extra Distance Long') ?> <autoset name="RetractionUndoExtraLongLength" ng-model="editor.movement.G11ExtraLongDistance"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="editor.movement.G11ExtraLongDistance" popover-placement="bottom" uib-popover="<?php _('Gets added to long retraction distance when reversing.') ?>" data-original-title popover-trigger="'focus'" min="0"> <div class="input-group-addon">mm</div> </div> </div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Undo Speed') ?> <autoset name="RetractionUndoSpeed" ng-model="editor.movement.G11Speed"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="editor.movement.G11Speed" popover-placement="bottom" uib-popover="<?php _('Speed when reversing retraction. Slower speeds then during retract might be better.') ?>" data-original-title popover-trigger="'focus'" min="0.1"> <div class="input-group-addon">mm/s</div> </div> </div> </div> </div>  <div class="panel panel-default" ng-repeat="ex in editor.extruders"> <div class="panel-heading"><i class="rs rs-extruder rs-fw"></i> <?php _('Extruder') ?> {{$index+1}} <button class="btn btn-danger pull-right btn-xs" ng-click="removeExtruder($index)"><i class="fa fa-trash-o"></i> <?php _('Delete Extruder') ?> </button> </div> <div class="panel-body"> <div class="row units"> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Alias') ?></label> <input class="form-control" type="text" step="any" placeholder="" ng-model="ex.alias" popover-placement="bottom" uib-popover="<?php _('For better recognition of the meant extruder.') ?>" data-original-title popover-trigger="'focus'"> </div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Filament Diameter') ?></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="ex.filamentDiameter" popover-placement="bottom" uib-popover="<?php _('Used for volume calculation.') ?>" data-original-title popover-trigger="'focus'" min="0.01" required> <div class="input-group-addon">mm</div> </div> </div> <div class="col-lg-4 visible-lg-block" style="height: 75px">&nbsp;</div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Max. Temperature') ?> <autoset name="extrMaxTemp[{{$index}}]" ng-model="ex.maxTemp"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="ex.maxTemp" popover-placement="bottom" uib-popover="<?php _('Maximum extruder temperature.') ?>" popover-trigger="'focus'" min="0.0001"> <div class="input-group-addon">°C</div> </div> </div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Heatup Speed') ?></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="ex.heatupPerSecond" popover-placement="bottom" uib-popover="<?php _('Temperature raised within one second.') ?>" data-original-title popover-trigger="'focus'" min="0.01" required> <div class="input-group-addon">°C/s</div> </div> </div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Cooldown Speed') ?></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="ex.cooldownPerSecond" popover-placement="bottom" uib-popover="<?php _('Temperature drop per second.') ?>" data-original-title popover-trigger="'focus'" min="0.01" required> <div class="input-group-addon">°C/s</div> </div> </div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Max. Speed') ?> <autoset name="extrMaxSpeed[{{$index}}]" ng-model="ex.maxSpeed"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="ex.maxSpeed" popover-placement="bottom" uib-popover="<?php _('Maximum extruder speed.') ?>" data-original-title popover-trigger="'focus'" required min="0.1"> <div class="input-group-addon">mm/s</div> </div> </div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Extrude Speed') ?></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="ex.extrudeSpeed" popover-placement="bottom" uib-popover="<?php _('Extruder speed if you click on extrude in manual controls.') ?>" data-original-title popover-trigger="'focus'" min="0.01" required> <div class="input-group-addon">mm/s</div> </div> </div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Retract Speed') ?></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="ex.retractSpeed" popover-placement="bottom" uib-popover="<?php _('Retract speed if you click on extrude in manual controls.') ?>" data-original-title popover-trigger="'focus'" min="0.01" required> <div class="input-group-addon">mm/s</div> </div> </div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Jerk') ?> <autoset name="extrJerk[{{$index}}]" ng-model="ex.eJerk"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="ex.eJerk" popover-placement="bottom" uib-popover="<?php _('Extruder will start with 50%% of jerk.') ?>" data-original-title popover-trigger="'focus'" min="0" required> <div class="input-group-addon">mm/s</div> </div> </div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Acceleration') ?> <autoset name="extrAcceleration[{{$index}}]" ng-model="ex.acceleration"> </autoset></label> <div class="input-group"> <input class="form-control" type="number" step="any" placeholder="" ng-model="ex.acceleration" popover-placement="bottom" uib-popover="<?php _('Extruder acceleration.') ?>" data-original-title popover-trigger="'focus'" min="0" required> <div class="input-group-addon">mm/s<sup>3</sup></div> </div> </div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Offset X') ?></label> <div class="input-group"> <input class="form-control" type="number" step="0.01" placeholder="" ng-model="ex.offsetX" popover-placement="bottom" uib-popover="<?php _('X offset of extruder. Some firmwares need this for multi extruder support.') ?>" data-original-title popover-trigger="'focus'" required> <div class="input-group-addon">mm</div> </div> </div> <div class="col-lg-4 col-xs-6 form-group"> <label><?php _('Offset Y') ?></label> <div class="input-group"> <input class="form-control" type="number" step="0.01" placeholder="" ng-model="ex.offsetY" popover-placement="bottom" uib-popover="<?php _('Y offset of extruder. Some firmwares need this for multi extruder support.') ?>" data-original-title popover-trigger="'focus'" required> <div class="input-group-addon">mm</div> </div> </div> </div> <h4><?php _('Predefined Extruder Temperatures') ?></h4> <table class="table table-bordered table-striped" style="max-width:520px"> <tr> <th><?php _('Name') ?></th> <th><?php _('Temperature') ?></th> <th style="width:150px"> <button class="btn btn-primary btn-xs" ng-click="extTempAdd(ex)"><i class="fa fa-plus"></i> <?php _('Add') ?></button> </th> </tr> <tr ng-repeat="r in ex.temperatures track by $index"> <td><input type="text" ng-model="r.name" class="form-control input-sm" required></td> <td> <div class="input-group maxw150"> <input type="number" ng-model="r.temp" class="form-control input-sm" integer required> <div class="input-group-addon">°C</div> </div> </td> <td> <button ng-hide="$first" class="btn btn-default btn-sm" ng-click="extTempUp(ex,$index)"> <i class="fa fa-arrow-up rs-big"></i> </button> <button ng-hide="$last" class="btn btn-default btn-sm" ng-click="extTempDown(ex,$index)"> <i class="fa fa-arrow-down rs-big"></i> </button> <button class="btn btn-danger btn-sm pull-right" ng-click="extTempDel(ex,$index)"> <i class="fa fa-trash-o rs-big"></i> </button> </td> </tr> </table> </div> </div> <button class="btn btn-primary" style="margin-bottom:40px" ng-click="addExtruder()"> <i class="fa fa-plus rs-bigtab"></i> <?php _('Add Extruder') ?> </button> </ng-form> </div>